Index: palm/trunk/SOURCE/advec_ws.f90
===================================================================
--- palm/trunk/SOURCE/advec_ws.f90	(revision 4465)
+++ palm/trunk/SOURCE/advec_ws.f90	(revision 4466)
@@ -6269,154 +6375,75 @@
                 k_mm  = k - 2 * ibit26
 
-                w_comp = w(k+1,j,i) + w(k,j,i)
-                flux_t = w_comp * rho_air(k+1) * (                             &
-                          ( 37.0_wp * ibit26 * adv_mom_5                       &
-                       +     7.0_wp * ibit25 * adv_mom_3                       &
-                       +              ibit24 * adv_mom_1                       &
-                          ) *                                                  &
-                             ( w(k+1,j,i)  + w(k,j,i)     )                    &
-                   -      (  8.0_wp * ibit26 * adv_mom_5                       &
-                       +              ibit25 * adv_mom_3                       &
-                          ) *                                                  &
-                             ( w(k_pp,j,i)  + w(k-1,j,i)  )                    &
-                   +      (           ibit26 * adv_mom_5                       &
-                          ) *                                                  &
-                             ( w(k_ppp,j,i) + w(k_mm,j,i) )                    &
-                                       )
-
-                diss_t = - ABS( w_comp ) * rho_air(k+1) * (                    &
-                          ( 10.0_wp * ibit26 * adv_mom_5                       &
-                       +     3.0_wp * ibit25 * adv_mom_3                       &
-                       +              ibit24 * adv_mom_1                       &
-                          ) *                                                  &
-                             ( w(k+1,j,i)   - w(k,j,i)    )                    &
-                   -      (  5.0_wp * ibit26 * adv_mom_5                       &
-                       +              ibit25 * adv_mom_3                       &
-                          ) *                                                  &
-                             ( w(k_pp,j,i)  - w(k-1,j,i)  )                    &
-                   +      (           ibit26 * adv_mom_5                       &
-                          ) *                                                  &
-                             ( w(k_ppp,j,i) - w(k_mm,j,i) )                    &
-                                               )
-!
-!--             Calculate the divergence of the velocity field. A respective
-!--             correction is needed to overcome numerical instabilities caused
-!--             by a not sufficient reduction of divergences near topography.
-                div = ( ( ( u_comp + gu ) * ( ibit18 + ibit19 + ibit20 )      &
-                  - ( u(k+1,j,i) + u(k,j,i)   )                               & 
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp )     &
-                                      )                                       &
-                  ) * ddx                                                     &
-              +   ( ( v_comp + gv ) * ( ibit21 + ibit22 + ibit23 )            &
-                  - ( v(k+1,j,i) + v(k,j,i)   )                               &
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k,j-1,i),23,1),  KIND = wp )    &
-                                      )                                       &
-                  ) * ddy                                                     &
-              +   ( w_comp * rho_air(k+1) * ( ibit24 + ibit25 + ibit26 )      &
-                - ( w(k,j,i)   + w(k-1,j,i)   ) * rho_air(k)                  &
-                                    * (                                       &
-                     REAL( IBITS(advc_flags_m(k-1,j,i),24,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k-1,j,i),25,1), KIND = wp )     &
-                   + REAL( IBITS(advc_flags_m(k-1,j,i),26,1), KIND = wp )     &
-                                      )                                       & 
-                  ) * drho_air_zw(k) * ddzu(k+1)                              &
-                ) * 0.5_wp
-
-
-
-                tend(k,j,i) = tend(k,j,i) - (                                 &
-                      ( ( flux_r + diss_r )                                   &
-                    -   ( flux_l + diss_l ) ) * ddx                           &
-                    + ( ( flux_n + diss_n )                                   &
-                    -   ( flux_s + diss_s ) ) * ddy                           &
-                    + ( ( flux_t + diss_t )                                   &
-                    -   ( flux_d + diss_d ) ) * drho_air_zw(k) * ddzu(k+1)    &
-                                            )  + div * w(k,j,i)
-
-#ifndef _OPENACC
-                swap_flux_x_local_w(k,j) = flux_r
-                swap_diss_x_local_w(k,j) = diss_r
-                swap_flux_y_local_w(k)   = flux_n
-                swap_diss_y_local_w(k)   = diss_n
-#endif
-                flux_d                   = flux_t
-                diss_d                   = diss_t
-
-                !$ACC ATOMIC
-                sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                    &
-                      + ( flux_t                                              &
-                       * ( w_comp - 2.0_wp * hom(k,1,3,0)                   ) &
-                       / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              ) &
-                        + diss_t                                              &
-                       *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              ) &
-                       / ( ABS( w_comp ) + 1.0E-20_wp                       ) &
-                        ) *   weight_substep(intermediate_timestep_count)
-
+                w_comp(k) = w(k+1,j,i) + w(k,j,i)
+                flux_t(k) = w_comp(k) * rho_air(k+1) * (                       &
+                           ( 37.0_wp * ibit26 * adv_mom_5                      &
+                        +     7.0_wp * ibit25 * adv_mom_3                      &
+                        +              ibit24 * adv_mom_1                      &
+                           ) *                                                 &
+                                      ( w(k+1,j,i)   + w(k,j,i)    )           &
+                    -      (  8.0_wp * ibit26 * adv_mom_5                      &
+                        +              ibit25 * adv_mom_3                      &
+                           ) *                                                 &
+                                      ( w(k_pp,j,i)  + w(k-1,j,i)  )           &
+                    +      (           ibit26 * adv_mom_5                      &
+                           ) *                                                 &
+                                      ( w(k_ppp,j,i) + w(k_mm,j,i) )           &
+                                                       )
+
+                diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (              &
+                           ( 10.0_wp * ibit26 * adv_mom_5                      &
+                        +     3.0_wp * ibit25 * adv_mom_3                      &
+                        +              ibit24 * adv_mom_1                      &
+                           ) *                                                 &
+                                      ( w(k+1,j,i)   - w(k,j,i)    )           &
+                    -      (  5.0_wp * ibit26 * adv_mom_5                      &
+                        +              ibit25 * adv_mom_3                      &
+                           ) *                                                 &
+                                      ( w(k_pp,j,i)  - w(k-1,j,i)  )           &
+                    +      (           ibit26 * adv_mom_5                      &
+                           ) *                                                 &
+                                      ( w(k_ppp,j,i) - w(k_mm,j,i) )           &
+                                                                )
              ENDDO
 
-             DO  k = nzb_max_l+1, nzt-1
-
-                u_comp = u(k+1,j,i+1) + u(k,j,i+1) - gu
-                flux_r = u_comp * (                                         &
-                      37.0_wp * ( w(k,j,i+1) + w(k,j,i)   )                    &
-                    -  8.0_wp * ( w(k,j,i+2) + w(k,j,i-1) )                    &
-                    +           ( w(k,j,i+3) + w(k,j,i-2) ) ) * adv_mom_5
-
-                diss_r = - ABS( u_comp ) * (                                &
-                      10.0_wp * ( w(k,j,i+1) - w(k,j,i)   )                    &
-                    -  5.0_wp * ( w(k,j,i+2) - w(k,j,i-1) )                    &
-                    +           ( w(k,j,i+3) - w(k,j,i-2) ) ) * adv_mom_5
-
-#ifdef _OPENACC
-!
-!--             Recompute the left fluxes.
-                u_comp_l = u(k+1,j,i) + u(k,j,i) - gu
-                flux_l   = u_comp_l * (                                     &
-                            37.0_wp * ( w(k,j,i)   + w(k,j,i-1)   )              &
-                          -  8.0_wp * ( w(k,j,i+1) + w(k,j,i-2) )              &
-                          +           ( w(k,j,i+2) + w(k,j,i-3) ) ) * adv_mom_5
-                diss_l   = - ABS( u_comp_l ) * (                            &
-                            10.0_wp * ( w(k,j,i)   - w(k,j,i-1)   )              &
-                          -  5.0_wp * ( w(k,j,i+1) - w(k,j,i-2) )              &
-                          +           ( w(k,j,i+2) - w(k,j,i-3) ) ) * adv_mom_5
-#else
-                flux_l = swap_flux_x_local_w(k,j)
-                diss_l = swap_diss_x_local_w(k,j)
-#endif
-
-                v_comp = v(k+1,j+1,i) + v(k,j+1,i) - gv
-                flux_n = v_comp * (                                         &
-                      37.0_wp * ( w(k,j+1,i) + w(k,j,i)   )                    &
-                    -  8.0_wp * ( w(k,j+2,i) + w(k,j-1,i) )                    &
-                    +           ( w(k,j+3,i) + w(k,j-2,i) ) ) * adv_mom_5
-
-                diss_n = - ABS( v_comp ) * (                                &
-                      10.0_wp * ( w(k,j+1,i) - w(k,j,i)   )                    &
-                    -  5.0_wp * ( w(k,j+2,i) - w(k,j-1,i) )                    &
-                    +           ( w(k,j+3,i) - w(k,j-2,i) ) ) * adv_mom_5
-
-#ifdef _OPENACC
-!
-!--             Recompute the south fluxes.
-                v_comp_s = v(k+1,j,i) + v(k,j,i) - gv
-                flux_s   = v_comp_s * (                                     &
-                           37.0_wp * ( w(k,j,i)   + w(k,j-1,i) )               &
-                         -  8.0_wp * ( w(k,j+1,i) +w(k,j-2,i)  )               &
-                         +           ( w(k,j+2,i) + w(k,j-3,i) ) ) * adv_mom_5
-                diss_s   = - ABS( v_comp_s ) * (                            &
-                           10.0_wp * ( w(k,j,i)   - w(k,j-1,i) )               &
-                         -  5.0_wp * ( w(k,j+1,i) - w(k,j-2,i) )               &
-                         +           ( w(k,j+2,i) - w(k,j-3,i) ) ) * adv_mom_5
-#else
-                flux_s = swap_flux_y_local_w(k)
-                diss_s = swap_diss_y_local_w(k)
-#endif
-
+             DO  k = nzb+2, nzt-2
+
+                ibit26 = REAL( IBITS(advc_flags_m(k,j,i),26,1), KIND = wp )
+                ibit25 = REAL( IBITS(advc_flags_m(k,j,i),25,1), KIND = wp )
+                ibit24 = REAL( IBITS(advc_flags_m(k,j,i),24,1), KIND = wp )
+
+                w_comp(k) = w(k+1,j,i) + w(k,j,i)
+                flux_t(k) = w_comp(k) * rho_air(k+1) * (                       &
+                           ( 37.0_wp * ibit26 * adv_mom_5                      &
+                        +     7.0_wp * ibit25 * adv_mom_3                      &
+                        +              ibit24 * adv_mom_1                      &
+                           ) *                                                 &
+                                      ( w(k+1,j,i)  + w(k,j,i)   )             &
+                    -      (  8.0_wp * ibit26 * adv_mom_5                      &
+                        +              ibit25 * adv_mom_3                      &
+                           ) *                                                 &
+                                      ( w(k+2,j,i)  + w(k-1,j,i) )             &
+                    +      (           ibit26 * adv_mom_5                      &
+                           ) *                                                 &
+                                      ( w(k+3,j,i)  + w(k-2,j,i) )             &
+                                                       )
+
+                diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (              &
+                           ( 10.0_wp * ibit26 * adv_mom_5                      &
+                        +     3.0_wp * ibit25 * adv_mom_3                      &
+                        +              ibit24 * adv_mom_1                      &
+                           ) *                                                 &
+                                      ( w(k+1,j,i) - w(k,j,i)    )             &
+                    -      (  5.0_wp * ibit26 * adv_mom_5                      &
+                        +              ibit25 * adv_mom_3                      &
+                           ) *                                                 &
+                                      ( w(k+2,j,i) - w(k-1,j,i)  )             &
+                    +      (           ibit26 * adv_mom_5                      &
+                           ) *                                                 &
+                                      ( w(k+3,j,i) - w(k-2,j,i)  )             &
+                                                                )
+             ENDDO
+
+             DO  k = nzt-1, nzt-1
 !
 !--             k index has to be modified near bottom and top, else array
@@ -6430,77 +6457,171 @@
                 k_mm  = k - 2 * ibit26
 
-                w_comp = w(k+1,j,i) + w(k,j,i)
-                flux_t = w_comp * rho_air(k+1) * (                           &
-                          ( 37.0_wp * ibit26 * adv_mom_5                        &
-                       +     7.0_wp * ibit25 * adv_mom_3                        &
-                       +              ibit24 * adv_mom_1                        &
-                          ) *                                                &
-                             ( w(k+1,j,i)  + w(k,j,i)     )                  &
-                   -      (  8.0_wp * ibit26 * adv_mom_5                        &
-                       +              ibit25 * adv_mom_3                        &
-                          ) *                                                &
-                             ( w(k_pp,j,i)  + w(k-1,j,i)  )                  &
-                   +      (           ibit26 * adv_mom_5                        &
-                          ) *                                                &
-                             ( w(k_ppp,j,i) + w(k_mm,j,i) )                  &
-                                       )
-
-                diss_t = - ABS( w_comp ) * rho_air(k+1) * (                  &
-                          ( 10.0_wp * ibit26 * adv_mom_5                        &
-                       +     3.0_wp * ibit25 * adv_mom_3                        &
-                       +              ibit24 * adv_mom_1                        &
-                          ) *                                                &
-                             ( w(k+1,j,i)   - w(k,j,i)    )                  &
-                   -      (  5.0_wp * ibit26 * adv_mom_5                        &
-                       +              ibit25 * adv_mom_3                        &
-                          ) *                                                &
-                             ( w(k_pp,j,i)  - w(k-1,j,i)  )                  &
-                   +      (           ibit26 * adv_mom_5                        &
-                          ) *                                                &
-                             ( w(k_ppp,j,i) - w(k_mm,j,i) )                  &
-                                               )
+                w_comp(k) = w(k+1,j,i) + w(k,j,i)
+                flux_t(k) = w_comp(k) * rho_air(k+1) * (                       &
+                           ( 37.0_wp * ibit26 * adv_mom_5                      &
+                        +     7.0_wp * ibit25 * adv_mom_3                      &
+                        +              ibit24 * adv_mom_1                      &
+                           ) *                                                 &
+                                      ( w(k+1,j,i)   + w(k,j,i)    )           &
+                    -      (  8.0_wp * ibit26 * adv_mom_5                      &
+                        +              ibit25 * adv_mom_3                      &
+                           ) *                                                 &
+                                      ( w(k_pp,j,i)  + w(k-1,j,i)  )           &
+                    +      (           ibit26 * adv_mom_5                      &
+                           ) *                                                 &
+                                      ( w(k_ppp,j,i) + w(k_mm,j,i) )           &
+                                                       )
+
+                diss_t(k) = - ABS( w_comp(k) ) * rho_air(k+1) * (              &
+                           ( 10.0_wp * ibit26 * adv_mom_5                      &
+                        +     3.0_wp * ibit25 * adv_mom_3                      &
+                        +              ibit24 * adv_mom_1                      &
+                           ) *                                                 &
+                                      ( w(k+1,j,i)   - w(k,j,i)    )           &
+                    -      (  5.0_wp * ibit26 * adv_mom_5                      &
+                        +              ibit25 * adv_mom_3                      &
+                           ) *                                                 &
+                                      ( w(k_pp,j,i)  - w(k-1,j,i)  )           &
+                    +      (           ibit26 * adv_mom_5                      &
+                           ) *                                                 &
+                                      ( w(k_ppp,j,i) - w(k_mm,j,i) )           &
+                                                                )
+             ENDDO
+
+!
+!--          Set resolved/turbulent flux at model top to zero (w-level). Hint: The
+!--          flux at nzt is defined at the scalar grid point nzt+1. Therefore, the
+!--          flux at nzt+1 is already outside of the model domain
+             flux_t(nzt) = 0.0_wp
+             diss_t(nzt) = 0.0_wp
+             w_comp(nzt) = 0.0_wp
+
+             flux_t(nzt+1) = 0.0_wp
+             diss_t(nzt+1) = 0.0_wp
+             w_comp(nzt+1) = 0.0_wp
+
+             DO  k = nzb+1, nzb_max_l
+
+                flux_d    = flux_t(k-1)
+                diss_d    = diss_t(k-1)
+
+                ibit20 = REAL( IBITS(advc_flags_m(k,j,i),20,1), KIND = wp )
+                ibit19 = REAL( IBITS(advc_flags_m(k,j,i),19,1), KIND = wp )
+                ibit18 = REAL( IBITS(advc_flags_m(k,j,i),18,1), KIND = wp )
+
+                ibit23 = REAL( IBITS(advc_flags_m(k,j,i),23,1), KIND = wp )
+                ibit22 = REAL( IBITS(advc_flags_m(k,j,i),22,1), KIND = wp )
+                ibit21 = REAL( IBITS(advc_flags_m(k,j,i),21,1), KIND = wp )
+
+                ibit26 = REAL( IBITS(advc_flags_m(k,j,i),26,1), KIND = wp )
+                ibit25 = REAL( IBITS(advc_flags_m(k,j,i),25,1), KIND = wp )
+                ibit24 = REAL( IBITS(advc_flags_m(k,j,i),24,1), KIND = wp )
 !
 !--             Calculate the divergence of the velocity field. A respective
-!--             correction is needed to overcome numerical instabilities caused
+!--             correction is needed to overcome numerical instabilities introduced
 !--             by a not sufficient reduction of divergences near topography.
-                div = ( ( u_comp + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx  &
-                    +   ( v_comp + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy  &
-                    +   (   w_comp                    * rho_air(k+1) -       &
-                          ( w(k,j,i)   + w(k-1,j,i) ) * rho_air(k)           &
-                        ) * drho_air_zw(k) * ddzu(k+1)                       &
+                div = ( ( ( u_comp(k) + gu ) * ( ibit18 + ibit19 + ibit20 )     &
+                        - ( u(k+1,j,i) + u(k,j,i)   )                           &
+                                          * (                                   &
+                           REAL( IBITS(advc_flags_m(k,j,i-1),18,1), KIND = wp ) &
+                         + REAL( IBITS(advc_flags_m(k,j,i-1),19,1), KIND = wp ) &
+                         + REAL( IBITS(advc_flags_m(k,j,i-1),20,1), KIND = wp ) &
+                                            )                                   &
+                        ) * ddx                                                 &
+                    +   ( ( v_comp(k) + gv ) * ( ibit21 + ibit22 + ibit23 )     &
+                        - ( v(k+1,j,i) + v(k,j,i)   )                           &
+                                          * (                                   &
+                           REAL( IBITS(advc_flags_m(k,j-1,i),21,1), KIND = wp ) &
+                         + REAL( IBITS(advc_flags_m(k,j-1,i),22,1), KIND = wp ) &
+                         + REAL( IBITS(advc_flags_m(k,j-1,i),23,1), KIND = wp ) &
+                                            )                                   &
+                        ) * ddy                                                 &
+                    +   ( w_comp(k)               * rho_air(k+1)                &
+                                                  * ( ibit24 + ibit25 + ibit26 )&
+                      - ( w(k,j,i) + w(k-1,j,i) ) * rho_air(k)                  &
+                                          * (                                   &
+                           REAL( IBITS(advc_flags_m(k-1,j,i),24,1), KIND = wp ) &
+                         + REAL( IBITS(advc_flags_m(k-1,j,i),25,1), KIND = wp ) &
+                         + REAL( IBITS(advc_flags_m(k-1,j,i),26,1), KIND = wp ) &
+                                            )                                   &
+                        ) * drho_air_zw(k) * ddzu(k+1)                          &
                       ) * 0.5_wp
 
-                tend(k,j,i) = tend(k,j,i) - (                                 &
-                      ( ( flux_r + diss_r )                                   &
-                    -   ( flux_l + diss_l ) ) * ddx                           &
-                    + ( ( flux_n + diss_n )                                   &
-                    -   ( flux_s + diss_s ) ) * ddy                           &
-                    + ( ( flux_t + diss_t )                                   &
-                    -   ( flux_d + diss_d ) ) * drho_air_zw(k) * ddzu(k+1)    &
-                                            )  + div * w(k,j,i)
-
+                tend(k,j,i) = tend(k,j,i) - (                                   &
+                            ( flux_r(k) + diss_r(k)                             &
+                          -   flux_l_w(k,j,tn) - diss_l_w(k,j,tn)   ) * ddx     &
+                          + ( flux_n(k) + diss_n(k)                             &
+                          -   flux_s_w(k,tn) - diss_s_w(k,tn)       ) * ddy     &
+                          + ( ( flux_t(k) + diss_t(k) )                         &
+                          -   ( flux_d    + diss_d    )                         &
+                                                ) * drho_air_zw(k) * ddzu(k+1)  &
+                                            ) + div * w(k,j,i)
 #ifndef _OPENACC
-                swap_flux_x_local_w(k,j) = flux_r
-                swap_diss_x_local_w(k,j) = diss_r
-                swap_flux_y_local_w(k)   = flux_n
-                swap_diss_y_local_w(k)   = diss_n
+                flux_l_w(k,j,tn) = flux_r(k)
+                diss_l_w(k,j,tn) = diss_r(k)
+                flux_s_w(k,tn)   = flux_n(k)
+                diss_s_w(k,tn)   = diss_n(k)
 #endif
-                flux_d                   = flux_t
-                diss_d                   = diss_t
-
-                !$ACC ATOMIC
-                sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                    &
-                      + ( flux_t                                              &
-                       * ( w_comp - 2.0_wp * hom(k,1,3,0)                   ) &
-                       / ( w_comp + SIGN( 1.0E-20_wp, w_comp )              ) &
-                        + diss_t                                              &
-                       *   ABS( w_comp - 2.0_wp * hom(k,1,3,0)              ) &
-                       / ( ABS( w_comp ) + 1.0E-20_wp                       ) &
-                        ) *   weight_substep(intermediate_timestep_count)
+!
+!--             Statistical Evaluation of w'w'.
+                sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                     &
+                            + ( flux_t(k)                                      &
+                             * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)           ) &
+                             / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )   ) &
+                              + diss_t(k)                                      &
+                             *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)      ) &
+                             / ( ABS( w_comp(k) ) + 1.0E-20_wp               ) &
+                              ) *   weight_substep(intermediate_timestep_count)
 
              ENDDO
+
+             DO  k = nzb_max_l+1, nzt-1
+
+                flux_d    = flux_t(k-1)
+                diss_d    = diss_t(k-1)
+!
+!--             Calculate the divergence of the velocity field. A respective
+!--             correction is needed to overcome numerical instabilities introduced
+!--             by a not sufficient reduction of divergences near topography.
+                div = ( ( u_comp(k) + gu - ( u(k+1,j,i) + u(k,j,i)   ) ) * ddx &
+                    +   ( v_comp(k) + gv - ( v(k+1,j,i) + v(k,j,i)   ) ) * ddy &
+                    +   ( w_comp(k)               * rho_air(k+1)               &
+                      - ( w(k,j,i) + w(k-1,j,i) ) * rho_air(k)                 &
+                        ) * drho_air_zw(k) * ddzu(k+1)                         &
+                      ) * 0.5_wp
+
+                tend(k,j,i) = tend(k,j,i) - (                                  &
+                            ( flux_r(k) + diss_r(k)                            &
+                          -   flux_l_w(k,j,tn) - diss_l_w(k,j,tn)   ) * ddx    &
+                          + ( flux_n(k) + diss_n(k)                            &
+                          -   flux_s_w(k,tn) - diss_s_w(k,tn)       ) * ddy    &
+                          + ( ( flux_t(k) + diss_t(k) )                        &
+                          -   ( flux_d    + diss_d    )                        &
+                                               ) * drho_air_zw(k) * ddzu(k+1)  &
+                                            ) + div * w(k,j,i)
+#ifndef _OPENACC
+                flux_l_w(k,j,tn) = flux_r(k)
+                diss_l_w(k,j,tn) = diss_r(k)
+                flux_s_w(k,tn)   = flux_n(k)
+                diss_s_w(k,tn)   = diss_n(k)
+#endif
+!
+!--             Statistical Evaluation of w'w'.
+                sums_ws2_ws_l(k,tn)  = sums_ws2_ws_l(k,tn)                     &
+                            + ( flux_t(k)                                      &
+                             * ( w_comp(k) - 2.0_wp * hom(k,1,3,0)          )  &
+                             / ( w_comp(k) + SIGN( 1.0E-20_wp, w_comp(k) )  )  &
+                              + diss_t(k)                                      &
+                             *   ABS( w_comp(k) - 2.0_wp * hom(k,1,3,0)     )  &
+                             / ( ABS( w_comp(k) ) + 1.0E-20_wp              )  &
+                              ) *   weight_substep(intermediate_timestep_count)
+
+             ENDDO
+
           ENDDO
        ENDDO
 
+       CALL cpu_log( log_point_s(87), 'advec_w_ws', 'stop' )
+
     END SUBROUTINE advec_w_ws
 
